﻿/*	elimanateWhite.jsx
選択されたレイヤーの白成分を除去

機能的に同じものなので
applyFilterTraceAll.jsx に置き換えて使用

*/
if(app.documents.length){
	var myTarget=app.activeDocument;
/*  Photoshop汎用
現在選択されているレイヤーを配列で戻す
展開オプション
    true or number,       レイヤーセットの中身のアートレイヤーを指定深度で展開する
    false or zero,      レイヤーセットを捨てて直下のアートレイヤーのみを返す
    undefined,  未着手でレイヤーセットのまま返す
*/
	getSelectedLayers=function(expandOption){ 
		//限定動作　背景レイヤが含まれているときにはエラーだけどとりあえず無視 選択レイヤがない場合もエラーだけどそれも無視する
		

//--------------------------------------レイヤからグループ
 var idGrp = stringIDToTypeID( "groupLayersEvent" );
 var descGrp = new ActionDescriptor();
 var refGrp = new ActionReference();
 refGrp.putEnumerated(charIDToTypeID( "Lyr " ),charIDToTypeID( "Ordn" ),charIDToTypeID( "Trgt" ));
 descGrp.putReference(charIDToTypeID( "null" ), refGrp );
 executeAction( idGrp, descGrp, DialogModes.ALL );//外部関数にして呼び出しすると妙に遅いので注意だ
//差分を取得してフレーム数を取得
//================== トレーラーのレイヤ数を取得
var resultLayers=new Array();
for (var ix=0;ix<app.activeDocument.activeLayer.layers.length;ix++){resultLayers.push(app.activeDocument.activeLayer.layers[ix])}
// =================== UNDOバッファを使用して復帰
var id8 = charIDToTypeID( "slct" );
    var desc5 = new ActionDescriptor();
    var id9 = charIDToTypeID( "null" );
        var ref2 = new ActionReference();
        var id10 = charIDToTypeID( "HstS" );
        var id11 = charIDToTypeID( "Ordn" );
        var id12 = charIDToTypeID( "Prvs" );  
        ref2.putEnumerated( id10, id11, id12 );
    desc5.putReference( id9, ref2 );
executeAction( id8, desc5, DialogModes.NO );
//展開オプションに従って、result配列の中身を展開するそれ以外はレイヤーセットを捨てる。
//オプション自体が省略されていれば従来どおり未加工の配列を戻す
    if(typeof expandOption == 'undefined'){
        return resultLayers;
    }else{
        var expandedLayers = [];
        for (var lix = 0 ; lix < resultLayers.length ; lix ++){
            if(resultLayers[lix].layers){;//LayerSet
                if(expandOption){
                    for(var slix=0;slix<resultLayers[lix].layers.length;slix++) expandedLayers.push(resultLayers[lix].layers[slix]);
                }
            }else{
                expandedLayers.push(resultLayers[lix]);//not LayerSet
            }
        }
            return expandedLayers;
    }
//選択レイヤの復帰はしない
}
/*
    初期化
*/
/*
eliminateWhite 

元スクリプトから以下の部分を変更
関数化してUNDO可能に
白レイヤーの作成を省略
オリジナルのソースレイヤを削除してリザルトを
オリジナルと同名のレイヤーに変更
透明度とブレンドモードを復帰
RGBモードに動作範囲を限定
ターゲットレイヤーがピクセルを持たない場合にNOP
*/
function eliminateWhite(targetLayer){
    if (typeof targetLayer == 'undefined') targetLayer = app.activeDocument.activeLayer;
    if ((targetLayer.kind != LayerKind.NORMAL)||(targetLayer.isBackgroundLayer)||(app.activeDocument.mode != DocumentMode.RGB)) return false;
    var bacupProps={blendMode:targetLayer.blendMode,opacity:targetLayer.opacity,maskOpt:targetLayer.layerMaskDensity};

    app.activeDocument.quickMaskMode=false;


//    sourceLayer.blendMode = BlendMode.NORMAL;
//    sourceLayer.opacity   = 100;
//    sourceLayer.layerMaskDensity = 0;
    
    app.activeDocument.activeLayer = targetLayer;
    app.activeDocument.selection.selectAll();
    app.activeDocument.selection.copy();
    app.activeDocument.selection.deselect();
    app.activeDocument.paste();
    var sourceLayer = app.activeDocument.activeLayer;
    
//アクティブレイヤー全体を一度白でペイントしておく    
    app.activeDocument.selection.selectAll();
    RGBColor = new SolidColor();
    RGBColor.red = 255;
    RGBColor.green = 255;
    RGBColor.blue = 255;
    app.activeDocument.selection.fill(RGBColor,ColorBlendMode.DARKEN, 100, false);

var rLayer=app.activeDocument.activeLayer.duplicate();

app.activeDocument.activeLayer=rLayer;

var idChnM = charIDToTypeID( "ChnM" );
    var desc3 = new ActionDescriptor();
    var idpresetKind = stringIDToTypeID( "presetKind" );
    var idpresetKindType = stringIDToTypeID( "presetKindType" );
    var idpresetKindCustom = stringIDToTypeID( "presetKindCustom" );
    desc3.putEnumerated( idpresetKind, idpresetKindType, idpresetKindCustom );
    var idMnch = charIDToTypeID( "Mnch" );
    desc3.putBoolean( idMnch, true );
    var idGry = charIDToTypeID( "Gry " );
        var desc4 = new ActionDescriptor();
        var idRd = charIDToTypeID( "Rd  " );
        var idPrc = charIDToTypeID( "#Prc" );
        desc4.putUnitDouble( idRd, idPrc, 100.000000 );
    var idChMx = charIDToTypeID( "ChMx" );
    desc3.putObject( idGry, idChMx, desc4 );
executeAction( idChnM, desc3, DialogModes.NO );


app.activeDocument.activeLayer=sourceLayer;
var gLayer=app.activeDocument.activeLayer.duplicate();
app.activeDocument.activeLayer=gLayer;

var idChnM = charIDToTypeID( "ChnM" );
    var desc29 = new ActionDescriptor();
    var idpresetKind = stringIDToTypeID( "presetKind" );
    var idpresetKindType = stringIDToTypeID( "presetKindType" );
    var idpresetKindCustom = stringIDToTypeID( "presetKindCustom" );
    desc29.putEnumerated( idpresetKind, idpresetKindType, idpresetKindCustom );
    var idMnch = charIDToTypeID( "Mnch" );
    desc29.putBoolean( idMnch, true );
    var idGry = charIDToTypeID( "Gry " );
        var desc30 = new ActionDescriptor();
        var idGrn = charIDToTypeID( "Grn " );
        var idPrc = charIDToTypeID( "#Prc" );
        desc30.putUnitDouble( idGrn, idPrc, 100.000000 );
    var idChMx = charIDToTypeID( "ChMx" );
    desc29.putObject( idGry, idChMx, desc30 );
executeAction( idChnM, desc29, DialogModes.NO );


app.activeDocument.activeLayer=sourceLayer;
var bLayer=app.activeDocument.activeLayer.duplicate();
app.activeDocument.activeLayer=bLayer;


var idChnM = charIDToTypeID( "ChnM" );
    var desc33 = new ActionDescriptor();
    var idpresetKind = stringIDToTypeID( "presetKind" );
    var idpresetKindType = stringIDToTypeID( "presetKindType" );
    var idpresetKindCustom = stringIDToTypeID( "presetKindCustom" );
    desc33.putEnumerated( idpresetKind, idpresetKindType, idpresetKindCustom );
    var idMnch = charIDToTypeID( "Mnch" );
    desc33.putBoolean( idMnch, true );
    var idGry = charIDToTypeID( "Gry " );
        var desc34 = new ActionDescriptor();
        var idBl = charIDToTypeID( "Bl  " );
        var idPrc = charIDToTypeID( "#Prc" );
        desc34.putUnitDouble( idBl, idPrc, 100.000000 );
    var idChMx = charIDToTypeID( "ChMx" );
    desc33.putObject( idGry, idChMx, desc34 );
executeAction( idChnM, desc33, DialogModes.NO );


rLayer.blendMode = BlendMode.DARKEN;
gLayer.blendMode = BlendMode.DARKEN;
app.activeDocument.activeLayer=rLayer;
app.activeDocument.activeLayer=app.activeDocument.activeLayer.merge();
maskLayer=app.activeDocument.activeLayer.merge();



app.activeDocument.activeLayer=maskLayer;

app.activeDocument.selection.selectAll();
app.activeDocument.selection.copy();

maskLayer.remove();


app.activeDocument.activeLayer=sourceLayer;
var resultLayer=app.activeDocument.activeLayer.duplicate();
app.activeDocument.activeLayer=resultLayer;

app.activeDocument.quickMaskMode=true;
app.activeDocument.selection.selectAll();
app.activeDocument.paste(true);
app.activeDocument.quickMaskMode=false;
app.activeDocument.selection.clear();
app.activeDocument.selection.deselect();
// =======================================================
var idRmvW = charIDToTypeID( "RmvW" );
executeAction( idRmvW, undefined, DialogModes.NO );
//実行直後にマージしてソースレイヤーにまとめる
sourceLayer.opacity=0;
targetLayer.opacity=0;
app.activeDocument.activeLayer=app.activeDocument.activeLayer.merge();
app.activeDocument.activeLayer=app.activeDocument.activeLayer.merge();
/*白レイヤーは不要
var whiteLayer=app.activeDocument.activeLayer.duplicate();
app.activeDocument.activeLayer=whiteLayer;


app.activeDocument.selection.selectAll();
RGBColor = new SolidColor();
RGBColor.red = 255;
RGBColor.green = 255;
RGBColor.blue = 255;
app.activeDocument.selection.fill(RGBColor,ColorBlendMode.NORMAL, 100, false);
*/

app.activeDocument.selection.deselect();

targetLayer.blendMode = bacupProps.blendMode;//ブレンドモード復帰
targetLayer.opacity   = bacupProps.opacity;//不透明度復帰
//sourceLayer.layerMaskDensity   = bacupProps.maskOpt;//レイヤマスク濃度復帰
//他のプロパティ（レイヤー効果・レイヤーマスク等）も復帰させるか？
//いっそ元レイヤーのピクセルを入れ替えたほうが良いかも？
//ソースのピクセルをすべて不透明度0にした後にマージでいける

//app.activeDocument.activeLayer=resultLayer;
}

//テンプレートの取得
//初期化終了
var canStart = ((app.activeDocument.mode==DocumentMode.RGB)&&(! app.activeDocument.activeLayer.isBackgroundLayer));
	if(canStart){
		//選択レイヤ取得
		//
		var myLayers=getSelectedLayers(true);

        var myUndo="ClearWhite";var myAction="";
			//ノーマルレイヤ時のみ処理 不透明度１００％リセットしてeliminateWhite アクションを実行
//myAction='for(var ix=0;ix<myLayers.length;ix ++){if(myLayers[ix].kind==LayerKind.NORMAL){app.activeDocument.activeLayer=myLayers[ix];if (myLayers[ix].opacity<100){myLayers[ix].opacity=100.0;};var idPly=charIDToTypeID("Ply ");var descAct=new ActionDescriptor();var idnull=charIDToTypeID("null");var refAct=new ActionReference();var idActn=charIDToTypeID("Actn");refAct.putName(idActn, "eliminateWhite");var idASet=charIDToTypeID("ASet");refAct.putName(idASet,"psAxe");descAct.putReference(idnull,refAct);executeAction(idPly,descAct, DialogModes.NO);}};';
//関数版
var myAction='for(var ix=0;ix<myLayers.length;ix ++){if(myLayers[ix].kind==LayerKind.NORMAL){app.activeDocument.activeLayer=myLayers[ix];if (myLayers[ix].opacity<100){myLayers[ix].opacity=100.0;};eliminateWhite(myLayers[ix]);}}';//

if(app.activeDocument.suspendHistory){app.activeDocument.suspendHistory(myUndo,myAction)}else{evel(myAction)}
	}else{
	alert(localize({en:"The document is not in RGB mode, or the background layer is selected.",ja:"ドキュメントがRGBモードではないか、または背景レイヤーが選択されています。"}));
	}
}else{
    alert("this is no Document")
}